//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3768133EF952.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3768133EF952.cm

//## begin module%3768133EF952.cp preserve=no
//## end module%3768133EF952.cp

//## Module: ComponentCreator%3768133EF952; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Model/Component/ComponentCreator.h

#ifndef COMPONENT_CREATOR_H
#define COMPONENT_CREATOR_H 1

//## begin module%3768133EF952.additionalIncludes preserve=no
//## end module%3768133EF952.additionalIncludes

//## begin module%3768133EF952.includes preserve=yes
//## end module%3768133EF952.includes

// Component
#include <XSModel/Model/Component/Component.h>
// ComponentGroup
#include <XSModel/Model/Component/ComponentGroup.h>


//## begin module%3768133EF952.declarations preserve=no
//## end module%3768133EF952.declarations

//## begin module%3768133EF952.additionalDeclarations preserve=yes
//## end module%3768133EF952.additionalDeclarations


//## begin ComponentCreator%3666C1D2F21C.preface preserve=yes
//## end ComponentCreator%3666C1D2F21C.preface

//## Class: ComponentCreator%3666C1D2F21C
//	Instantiates Components: virtual constructor
//	using Factory Method
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%399B01910066;AddTableComponent { -> }
//## Uses: <unnamed>%399B01B403B5;MulTableComponent { -> }
//## Uses: <unnamed>%399B01CB0182;ConComponent { -> }
//## Uses: <unnamed>%399B01DF0204;MixComponent { -> }
//## Uses: <unnamed>%3804B64B9398;ComponentGroup { -> }
//## Uses: <unnamed>%3804B6486348;friend Component { -> }
//## Uses: <unnamed>%3BB8A2A801F7;SumComponent { -> }

class ComponentCreator 
{
  //## begin ComponentCreator%3666C1D2F21C.initialDeclarations preserve=yes
  //## end ComponentCreator%3666C1D2F21C.initialDeclarations

  public:
    //## Constructors (generated)
      ComponentCreator();

    //## Destructor (generated)
      virtual ~ComponentCreator();


    //## Other Operations (specified)
      //## Operation: GetComponent%376812C9F7A8;         C++
      Component* GetComponent (const string& name, CGroupBase* group);

      //## Operation: GetComponent%376812C9F7AA;    C++
      Component* GetComponent (const string& id, CGroupBase* group, const string& type, int table = false);

      //## Operation: reset%376812C9F7AE;   C++
      //	Additional Public Declarations
      void reset ();

    // Additional Public Declarations
      //## begin ComponentCreator%3666C1D2F21C.public preserve=yes
      //## end ComponentCreator%3666C1D2F21C.public

  protected:
    // Additional Protected Declarations
      //## begin ComponentCreator%3666C1D2F21C.protected preserve=yes
      //## end ComponentCreator%3666C1D2F21C.protected

  private:

    //## Other Operations (specified)
      //## Operation: Make%376812C9F7AF;         C++
      virtual Component* Make (const string& name, CGroupBase* group);

      //## Operation: Make%376812C9F7B1;    C++
      virtual Component* Make (const string& idstring, CGroupBase* group, const string& type, int table = false);

    // Additional Private Declarations
      //## begin ComponentCreator%3666C1D2F21C.private preserve=yes
      //## end ComponentCreator%3666C1D2F21C.private

  private: //## implementation
    // Data Members for Associations

      //## Association: XSModel::Model::Component::<unnamed>%3A8BFE0502B1
      //## Role: ComponentCreator::component%3A8BFE0601B8
      //## begin ComponentCreator::component%3A8BFE0601B8.role preserve=no  private: Component { -> 1RFHgN}
      Component* m_component;
      //## end ComponentCreator::component%3A8BFE0601B8.role

    // Additional Implementation Declarations
      //## begin ComponentCreator%3666C1D2F21C.implementation preserve=yes
      //## end ComponentCreator%3666C1D2F21C.implementation

};

//## begin ComponentCreator%3666C1D2F21C.postscript preserve=yes
//## end ComponentCreator%3666C1D2F21C.postscript

// Class ComponentCreator 


//## Other Operations (inline)
inline void ComponentCreator::reset ()
{
  m_component = 0;




  //## begin ComponentCreator::reset%376812C9F7AE.body preserve=yes
  //## end ComponentCreator::reset%376812C9F7AE.body
}

//## begin module%3768133EF952.epilog preserve=yes
//## end module%3768133EF952.epilog


#endif
